package net.t2code.commandguiv2.Spigot.config.config;

import net.t2code.commandguiv2.Spigot.Main;
import net.t2code.commandguiv2.Spigot.config.configConverter.ConfigConverterV5;
import net.t2code.commandguiv2.Spigot.config.configConverter.ConfigConverterV6;
import net.t2code.commandguiv2.Util;
import net.t2code.t2codelib.SPIGOT.api.messages.T2Csend;
import net.t2code.t2codelib.SPIGOT.api.yaml.T2Cconfig;
import org.bukkit.configuration.file.YamlConfiguration;

import java.io.File;
import java.io.IOException;

public class ConfigSelect {

    public static void selectConfig() throws IOException {
        File config = new File(Main.getPath(), "config.yml");
        YamlConfiguration yamlConfiguration = YamlConfiguration.loadConfiguration(config);

        if (yamlConfiguration.contains("ConfigVersion")) {
            if (yamlConfiguration.getInt("ConfigVersion") < Util.getConfigVersion() && new File(Main.getPath(), "config.yml").exists()) {
                T2Csend.console(Util.getPrefix() + " §4----------------------");
                T2Csend.console(Util.getPrefix() + " ");
                T2Csend.console(Util.getPrefix() + " §6New features have been added to CommandGUI. The Config is adapted!");
                T2Csend.console(Util.getPrefix() + " ");
                T2Csend.console(Util.getPrefix() + " §4----------------------");
                if (yamlConfiguration.getInt("ConfigVersion") < 5) {
                    ConfigConverterV5.convert();
                    selectConfig();
                    return;
                }
                if (yamlConfiguration.getInt("ConfigVersion") < 6) {
                    ConfigConverterV6.convert();
                    selectConfig();
                    return;
                }
            }
        }

        yamlConfiguration.set(Config.configVersion.path, Config.configVersion.value);
        for (Config value : Config.values()) {
            T2Cconfig.set(value.path, value.value, yamlConfiguration);
            value.value = T2Cconfig.selectObject(Util.getPrefix(), value.path, yamlConfiguration);
        }

        try {
            yamlConfiguration.save(config);
        } catch (
                IOException e) {
            e.printStackTrace();
        }
        T2Csend.console(Util.getPrefix() + " §2Config was loaded successfully.");
    }
}
