package net.t2code.commandguiv2.Spigot.config.configConverter;

import net.t2code.commandguiv2.Spigot.Main;
import net.t2code.commandguiv2.Spigot.config.config.Config;
import net.t2code.commandguiv2.Util;
import net.t2code.t2codelib.SPIGOT.api.messages.T2Creplace;
import org.bukkit.configuration.file.YamlConfiguration;

import java.io.File;
import java.io.IOException;

public class ConfigConverterV6 {
    private static final File configOld = new File(Main.getPath(), "config.yml");
    private static final YamlConfiguration yamlConfigurationOld = YamlConfiguration.loadConfiguration(configOld);

    public static void convert() throws IOException {
        set(Config.debug, "Plugin.Debug");

        set(Config.updateCheckOnJoin, "Plugin.updateCheck.onJoin");
        set(Config.updateCheckSeePreReleaseUpdates , "Plugin.updateCheck.seePreReleaseUpdates");
        set(Config.updateCheckTimeInterval , "Plugin.updateCheck.timeInterval");
        set(Config.helpAlias , "Plugin.HelpAlias");
        set(Config.adminSubCommand , "Plugin.AdminSubCommand");
        set(Config. language, "Plugin.language");
        set(Config. currency, "Plugin.Currency");
        set(Config.defaultGUI , "Plugin.DefaultGUI");

        set(Config.storage , "Storage.Type");
        set(Config. mysqlIp, "Storage.MySQL.IP");
        set(Config. mysqlPort, "Storage.MySQL.Port");
        set(Config.mysqlDatabase , "Storage.MySQL.Database");
        set(Config. mysqlUser, "Storage.MySQL.User");
        set(Config. mysqlPassword, "Storage.MySQL.Password");
        set(Config. mysqlSSL, "Storage.MySQL.SSL");

        set(Config. useItemEnable, "UseItem.Enable");
        set(Config.useItemAllowToggle , "UseItem.AllowToggle");
        set(Config.useItemAllowSetSlot , "UseItem.AllowSetSlot");
        set(Config. useItemBlockMoveAndDrop, "UseItem.BlockMoveAndDrop");
        set(Config. useItemOpenGUI, "UseItem.OpenGUI");
        set(Config. useItemPermission, "UseItem.Permission.NeededToUse");
        set(Config. useItemKeepAtCommandClear, "UseItem.KeepAtCommandClear");

        set(Config. useItemInventorySlotFreeSlot, "UseItem.InventorySlot.FreeSlot");
        set(Config. useItemInventorySlot, "UseItem.InventorySlot.Slot");
        set(Config.useItemInventorySlotEnforce , "UseItem.InventorySlot.SlotEnforce");
        set(Config.useItemMaterial , "UseItem.Item.Material");
      
        set(Config.useItemPlayerHeadEnable , "UseItem.Item.PlayerHead.Enable");
        set(Config. useItemBase64Enable, "UseItem.Item.PlayerHead.Base64.Enable");
        set(Config.useItemBase64value , "UseItem.Item.PlayerHead.Base64.Base64Value");
        set(Config.useItemPlayerWhoHasOpenedTheGUI , "UseItem.Item.PlayerHead.PlayerWhoHasOpenedTheGUI");
        set(Config. useItemPlayerName, "UseItem.Item.PlayerHead.PlayerName");
        set(Config. useItemName, "UseItem.Item.Name");
        set(Config.useItemLore , "UseItem.Item.Lore");
        set(Config. useItemGiveOnEveryJoin, "UseItem.Join.GiveOnEveryJoin");
        set(Config. useItemGiveOnlyOnFirstJoin, "UseItem.Join.GiveOnlyOnFirstJoin");
        set(Config. cursorToGUIItemOnLogin, "UseItem.Join.Cursor.ToGUIItem.OnLogin.Enable");
        set(Config. cursorToGUIItemOnlyOnFirstLogin, "UseItem.Join.Cursor.ToGUIItem.Spigot.OnlyOnFirstLogin");
        set(Config. useItemServerChange, "UseItem.Join.Cursor.ToGUIItem.Bungee.OnServerChange");

        set(Config. toggleItemOnOrYesBase64, "Toggle.Items.OnOrYes.Item.Base64.Enable");
        set(Config.toggleItemOnOrYesBase64Value , "Toggle.Items.OnOrYes.Item.Base64.Base64Value");
        set(Config.toggleItemOnOrYesMaterial , "Toggle.Items.OnOrYes.Item.Material");

        set(Config.toggleItemOffOrNoBase64 , "Toggle.Items.OffOrNo.Item.Base64.Enable");
        set(Config. toggleItemOffOrNoBase64Value, "Toggle.Items.OffOrNo.Item.Base64.Base64Value");
        set(Config.toggleItemOffOrNoMaterial , "Toggle.Items.OffOrNo.Item.Material");

        set(Config.togglePermTrue , "Toggle.Permission.Commands.True");
        set(Config.togglePermFalse , "Toggle.Permission.Commands.False");

        set(Config. placeholderTrue, "Placeholder.True");
        set(Config. placeholderFalse, "Placeholder.False");

        set(Config. soundEnable, "Sound.Enable");
        set(Config. soundOpenInventoryEnable, "Sound.OpenInventory.Enable");
        set(Config. soundOpenInventoryInput, "Sound.OpenInventory.Sound");
        set(Config. soundClickEnable, "Sound.Click.Enable");
        set(Config. soundClickInput, "Sound.Click.Sound");
        set(Config.soundNoMoneyEnable , "Sound.NoMoney.Enable");
        set(Config.soundNoMoneyInput , "Sound.NoMoney.Sound");

        set(Config. soundNoInventorySpaceEnable, "Sound.NoInventorySpace.Enable");
        set(Config.soundNoInventorySpaceInput , "Sound.NoInventorySpace.Sound");
        set(Config.soundGiveEnable , "Sound.Give.Enable");
        set(Config.soundGiveInput , "Sound.Give.Sound");
        set(Config. soundPlayerNotFoundEnable, "Sound.PlayerNotFound.Enable");
        set(Config. soundPlayerNotFoundInput, "Sound.PlayerNotFound.Sound");

        set(Config. useItemGameModeChangeEnable, "Advanced.UseItem.GameMode.Change.Enable");
        set(Config. useItemGameModeChangeDelayInTicks, "Advanced.UseItem.GameMode.Change.DelayInTicks");
        set(Config. useItemGameModeProtection, "Advanced.UseItem.GameMode.Protection.Enable");
        set(Config.useItemGameModeRemoveItemWhenItIsDisabled , "Advanced.UseItem.GameMode.Protection.RemoveItemWhenItIsDisabled");
        set(Config. useItemGameModeMode, "Advanced.UseItem.GameMode.Protection.Mode");

        set(Config.useItemGameModeList , "Advanced.UseItem.GameMode.Protection.List");

        set(Config.useItemWorldChangeEnable , "Advanced.UseItem.World.Change.Enable");
        set(Config.useItemWorldChangeDelayInTicks , "Advanced.UseItem.World.Change.DelayInTicks");
        set(Config.useItemWorldProtection , "Advanced.UseItem.World.Protection.Enable");
        set(Config.useItemWorldRemoveItemWhenItIsDisabled , "Advanced.UseItem.World.Protection.RemoveItemWhenItIsDisabled");
        set(Config. useItemWorldMode, "Advanced.UseItem.World.Protection.Mode");
        set(Config. useItemWorldList, "Advanced.UseItem.World.Protection.List");

        set(Config.disableInfoBySneak , "Advanced.UseItem.DisableInfoBySneak");


        set(Config.useItemItemBlockBlacklist , "Advanced.UseItem.ItemBlockBlacklist");


        configOld.renameTo(new File(Main.getPath(), "configV5.yml"));
    }

    private static void set(Config obj, String path) {
        if (!yamlConfigurationOld.contains(path)) return;
        obj.value = yamlConfigurationOld.get(path);
    }
}
